

import std.stream : File, FileMode;
import std.contracts : enforce;
import std.stdio : writeln;

int mode_usage() {
    writeln("usage:");
    writeln("\tdmcexefix exefile");
    return 0;
}

int mode_fix(string file) {
    try {
        scope fs = new File(file, FileMode.In | FileMode.Out);
        // EXEファイルか確認
        fs.position = 0x00;
        enforce(fs.getc() == 'M');
        enforce(fs.getc() == 'Z');
        fs.position = 0x60;
        enforce(fs.getc() == 'P');
        enforce(fs.getc() == 'E');
        
        fs.position = 0xA0; // major OS version
        fs.write(4);
        fs.position = 0xA8; // major/minor subsystem version
        fs.write(4);
        
        return 0;
    }
    catch (Object e) {
        writeln("Error!");
        writeln(e.toString());
        return 1;
    }
}

int main(string[] args) {
    if (args.length != 2) return mode_usage();
    if (args.length == 2) return mode_fix(args[1]);
    assert(0);
}





